# Pandemonium Engine

<p align="center">
  <a href="https://godotengine.org">
    <img src="logo_outlined.svg" width="400" alt="Pandemonium Engine logo">
  </a>
</p>

A 3.x [Godot Engine](https://godotengine.org) fork where I hack and slash and cause mayhem and destruction to all things good and godot.

Similar idea to godot 4.0, but taken in a completely different direction.

It contains all of my currently in use engine modules. See the [changelog](https://github.com/Relintai/pandemonium_engine/blob/master/CHANGELOG.md) for a more comprehensive list of changes.

## 2D and 3D cross-platform game engine

Pandemonium Engine is a feature-packed, cross-platform game engine to create 2D and 3D games from a unified interface.
It provides a comprehensive set of [common tools](https://godotengine.org/features), so that users can focus on making games
without having to reinvent the wheel. Games can be exported with one click to a
number of platforms, including the major desktop platforms (Linux, macOS,
Windows), mobile platforms (Android, iOS), as well as Web-based platforms
(HTML5) and [consoles](https://docs.godotengine.org/en/latest/tutorials/platform/consoles.html).

## Free, open source and community-driven

Godot is completely free and open source under the very permissive [MIT license](https://godotengine.org/license).
No strings attached, no royalties, nothing. The users' games are theirs, down
to the last line of engine code. Godot's development is fully independent and
community-driven, empowering users to help shape their engine to match their
expectations. It is supported by the [Software Freedom Conservancy](https://sfconservancy.org/)
not-for-profit.

Before being open sourced in [February 2014](https://github.com/godotengine/godot/commit/0b806ee0fc9097fa7bda7ac0109191c9c5e0a1ac),
Godot had been developed by [Juan Linietsky](https://github.com/reduz) and
[Ariel Manzur](https://github.com/punto-) (both still maintaining the project) for several
years as an in-house engine, used to publish several work-for-hire titles.

## Getting the engine

### Binary downloads

I don't have anything (lik an official webpage) set up at the moment, but temporarily you can download binaries from the github actions tab [[here]](https://github.com/Relintai/pandemonium_engine).

### Compiling from source

Compiling is exactly the same as for Godot, so [See the official Godot docs](https://docs.godotengine.org/en/latest/development/compiling/)
for compilation instructions for every supported platform.

## Documentation and demos

The documantation is available in this repo under the doc/engine folder. [[Here]](https://github.com/Relintai/pandemonium_engine/tree/master/doc/engine).

You can also look at the official Godot documentation. It is hosted on [ReadTheDocs](https://docs.godotengine.org), and
is maintained by the Godot community in its own [GitHub repository](https://github.com/godotengine/godot-docs).

The class docs are accessible from the editor.

You can also look at the official godot demos in their own [GitHub repository](https://github.com/godotengine/godot-demo-projects)
as well as a list of [awesome Godot community resources](https://github.com/godotengine/awesome-godot).

There are also a number of other
[learning resources](https://docs.godotengine.org/en/latest/community/tutorials.html)
provided by the community, such as text and video tutorials, demos, etc.
